#pragma once 

//////////////////////////////////////////////////////////////////////////
// 1**
inline LPCSTR rep150() { return "150 File status okay; about to open data connection. \r\n" ; }

//////////////////////////////////////////////////////////////////////////
// 2** 
inline LPCSTR rep200() { return "200 Command okay. \r\n" ; }
inline LPCSTR rep202() { return "202 Command not implemented, superfluous at this site. \r\n" ; }
inline LPCSTR rep220() { return "220 Service ready for new user. \r\n" ; }
inline LPCSTR rep221() { return "221 Service closing control connection. \r\n" ; }
inline LPCSTR rep226() { return "226 Closing data connection. \r\n" ; } 

inline LPCSTR rep230() { return "230 User logged in, proceed. \r\n" ; } 
inline LPCSTR rep250() { return "250 Requested file action okay, completed. \r\n" ; }

inline LPCSTR rep257( LPSTR buf, LPCSTR folder ) 
{ 
   sprintf( buf, "257 \"%s\" Created. \r\n", folder ) ;
   return buf ; 
}

//////////////////////////////////////////////////////////////////////////
// 3**
inline LPCSTR rep331() { return "331 User name okay, need password. \r\n" ; } 

//////////////////////////////////////////////////////////////////////////
// 4**
inline LPCSTR rep450() { return "450 Requested file action not taken. \r\n " ; }
inline LPCSTR rep425() { return "425 Can't open data connection. \r\n " ; }
inline LPCSTR rep426() { return "426 Connection closed; transfer aborted. \r\n " ; }
inline LPCSTR rep451() { return "451 Requested action aborted. Local error in processing. \r\n " ; }

//////////////////////////////////////////////////////////////////////////
// 5**
inline LPCSTR rep500() { return "500 Syntax error, command unrecognized. \r\n" ; }
inline LPCSTR rep501() { return "501 Syntax error in parameters or arguments. \r\n" ; }
inline LPCSTR rep530() { return "530 Not logged in. \r\n" ; } 
inline LPCSTR rep550() { return "550 Requested action not taken. \r\n" ; } 

//////////////////////////////////////////////////////////////////////////
//
// replies parser
//

inline size_t ParseReply( LPCSTR rep ) // returns 0 if unknown 
{
   int d = rep[0] - '0' ;

   if( d >= 1 && d <= 5 )
      return ( size_t ) d ;
   else 
      return 0 ; // not valid 
}

inline std::wstring FormatReply( LPCSTR rep ) 
{
   USES_CONVERSION ;
   LPSTR p = strchr( rep, '\r' ) ;

   if( p != 0 )
      return string( A2W( rep ), p - rep ) ;

   return A2W( rep ) ;
}
