#pragma once 
#include "FileTracer.h"

class CMainWindow 
   : public CDialogImpl < CMainWindow >
   , public iCommonTracer 
{
   typedef 
      CDialogImpl< CMainWindow > 
      Base ;

public:
   CMainWindow () ;
  ~CMainWindow () ;

  enum { IDD = 100 } ;

  enum 
  {
     IDL_TRACE       = 101,
     IDB_STOPSERVER  = 110,
     IDB_EXIT        = 111,
     IDB_STARTSERVER = 112
  } ;

  LRESULT OnInitDialog  ( UINT, WPARAM, LPARAM, BOOL& ) ;
  LRESULT OnClose       ( UINT, WPARAM, LPARAM, BOOL& ) ;
  LRESULT OnDestroy     ( UINT, WPARAM, LPARAM, BOOL& ) ;

  LRESULT OnStartServer ( WORD, WORD, HWND, BOOL& ) ;
  LRESULT OnStopServer  ( WORD, WORD, HWND, BOOL& ) ;
  LRESULT OnExit        ( WORD, WORD, HWND, BOOL& ) ;

BEGIN_MSG_MAP( CMainWindow )
   MESSAGE_HANDLER( WM_INITDIALOG,  OnInitDialog   )
   MESSAGE_HANDLER( WM_CLOSE,       OnClose        )
   MESSAGE_HANDLER( WM_DESTROY,     OnDestroy      )

   COMMAND_HANDLER( IDB_STARTSERVER , BN_CLICKED, OnStartServer   )
   COMMAND_HANDLER( IDB_STOPSERVER  , BN_CLICKED, OnStopServer    )
   COMMAND_HANDLER( IDB_EXIT        , BN_CLICKED, OnExit          )
END_MSG_MAP  ()

// void Create() ;

//-- iCommonTracer 
   void __stdcall Trace ( LPCWSTR msg ) ;

private:
   WTL::CListViewCtrl m_list ;

private:
   IFTPServerPtr     m_pServer    ;
};