#pragma once

#include "Interfaces.h"

struct UsersParser
{
   typedef std::map< string, string > UserList ; // name & password

   UsersParser( LPCSTR filename )  
   {
      USES_CONVERSION ;

      FILE* f = fopen( filename, "r" ) ;
      if( f != NULL )
      {
         char user [ MAX_PATH ] ;
         char pass [ MAX_PATH ] ;

         while ( fscanf( f, "%s %s", user, pass ) != EOF )
            list_[ A2W( user ) ] = A2W( pass ) ;        

         fclose( f ) ;
      }
   }

   UserList const& GetUserList() { return list_ ; }

private:
   UserList list_ ;
};
